// Copyright 2008-2009 Philip Allison <sane@not.co.uk>

//    This file is part of cteddy.
//
//    cteddy is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    cteddy is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with cteddy.  If not, see <http://www.gnu.org/licenses/>.


//
// Includes
//

// Project headers
#ifdef HAVE_CONFIG_H
#	include "config.h"
#endif

// Language headers
#include <string>
#include <iostream>
#include <cstring>
#include <cerrno>

// Library headers
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#ifdef __USE_SM
#	include <X11/SM/SMlib.h>
#endif

// System headers
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#ifdef __USE_SM
#	include <syslog.h>
#endif


//
// Globals
//

// Main window
GtkWidget* window = NULL;

// GTK/GDK returned pointer
GError* gerr = NULL;

// Image to display and its dimensions
GdkPixbuf* pixbuf = NULL;
gint width = 0, height = 0;

// Bitmap generated by thresholding image's alpha channel
// Used for window input (and sometimes shape) mask
GdkBitmap* bitmap = NULL;

// Whether or not the key binding for quit is disabled
bool noquit = false;

#ifdef __USE_SM
// Options structure - needed so that sm_save_yourself can know about the
// values of various program options which are usually only in main()'s scope
struct smopts
{
	bool sticky;
	bool noquit;
	bool ontop;
	char* image;
	char* progname;
	char* smcid;
};
#endif


//
// Implementation
//

// Re-paint the window when necessary
gboolean handle_expose(GtkWidget* widget, GdkEventExpose* event)
{
	cairo_t* cairo = gdk_cairo_create(widget->window);

	// Blank the surface
	cairo_set_source_rgba (cairo, 1.0f, 1.0f, 1.0f, 0.0f);
	cairo_set_operator (cairo, CAIRO_OPERATOR_SOURCE);
	cairo_paint (cairo);

	// Set cairo's source pattern from the desired image
	gdk_cairo_set_source_pixbuf(cairo, pixbuf, 0.0f, 0.0f);

	// Draw the image
	cairo_rectangle(cairo, 0.0f, 0.0f,
		static_cast<double>(width), static_cast<double>(height));
	cairo_fill(cairo);
	
	cairo_destroy(cairo);
	
	return false;
}

// Handle mouse click events
gboolean window_clicked(GtkWidget* widget, GdkEventButton* event)
{
	if (event->type == GDK_BUTTON_PRESS)
		// Move the window with the mouse
		gtk_window_begin_move_drag(GTK_WINDOW(window),
			event->button, static_cast<gint>(event->x_root),
			static_cast<gint>(event->y_root), event->time);
	return true;
}

// Set up an RGBA colourmap for the window
void handle_screen(GtkWidget* window, GdkScreen* old, gpointer data)
{
	GdkScreen* s = gtk_widget_get_screen(window);
	GdkColormap* c = gdk_screen_get_rgba_colormap(s);

	// Clear window's shape mask
	gtk_widget_shape_combine_mask(window, NULL, 0, 0);

	if (!c)
	{
		// Use standard RGB colourmap if we must.
		c = gdk_screen_get_rgb_colormap(s);
		// Also, set window's shape mask so that even without
		// a true RGBA window, we don't get an ugly black border
		if (bitmap)
			gtk_widget_shape_combine_mask(window, bitmap, 0, 0);
	}

	gtk_widget_set_colormap(window, c);
}

// Handle key press events
void handle_key_press(GtkWidget *Window, GdkEventKey *theEvent)
{
	switch( theEvent->keyval )
	{
		case GDK_q:
			// Quit on "q"
			if (!noquit)
				gtk_main_quit();
			break;

		default:
			// Ignore all other keys
			break;
	}

}

// Function for seeing whether or not a particular image file exists.
// If we find a file, copy the filename into image and return true, otherwise return false.
bool image_exists(std::string& image, const std::string& find_image)
{

	// Set of image extensions to try appending when searching for an image
	static const char* extensions[16];
	extensions[0] = ".png"; extensions[1] = ".gif"; extensions[2] = ".jpg";
	extensions[3] = ".jpeg"; extensions[4] = ".pnm"; extensions[5] = ".xpm";
	extensions[6] = ".tif"; extensions[7] = ".tiff";
	extensions[8] = ".PNG"; extensions[9] = ".GIF"; extensions[10] = ".JPG";
	extensions[11] = ".JPEG"; extensions[12] = ".PNM"; extensions[13] = ".XPM";
	extensions[14] = ".TIF"; extensions[15] = ".TIFF";
	
	struct stat s;
	// Try unadulterated filename, then extensions in lower & upper case
	for (size_t i = 0; i < 16; ++i)
	{
		std::string ximage(find_image);
		if (i > 0) ximage.append(extensions[i - 1]);
		if (stat(ximage.c_str(), &s) == 0)
		{
			image = ximage;
			return true;
		}
	}
	return false;
}

#ifdef __USE_SM
// Session management "SaveYourself" callback
void sm_save_yourself(SmcConn conn, SmPointer data, int type, Bool shutdown, int istyle, Bool fast)
{
	// Set the required properties for session management
	smopts* opts = static_cast<smopts*>(data);
	
	// Program name
	SmProp progname;
	progname.name = SmProgram;
	progname.type = SmARRAY8;
	progname.num_vals = 1;
	SmPropValue progname_value;
	progname_value.length = strlen(opts->progname);
	progname_value.value = opts->progname;
	progname.vals = &progname_value;
	
	// User ID
	SmProp uid;
	uid.name = SmUserID;
	uid.type = SmARRAY8;
	uid.num_vals = 1;
	SmPropValue uid_value;
	const char* c_uidstr = g_get_user_name();
	char* uidstr = new char[strlen(c_uidstr) + 1];
	strcpy(uidstr, c_uidstr);
	uid_value.length = strlen(c_uidstr);
	uid_value.value = uidstr;
	uid.vals = &uid_value;
	
	// Current working directory
	SmProp cwd;
	cwd.name = SmCurrentDirectory;
	cwd.type = SmARRAY8;
	cwd.num_vals = 1;
	SmPropValue cwd_value;
	const char* c_cwdstr = g_get_current_dir();
	char* cwdstr = new char[strlen(c_cwdstr) + 1];
	strcpy(cwdstr, c_cwdstr);
	cwd_value.length = strlen(c_cwdstr);
	cwd_value.value = cwdstr;
	cwd.vals = &cwd_value;
	
	// Clone & restart commands
	SmPropValue command[6];
	int numvals = 0;
	command[numvals++] = progname_value;
	SmProp restartcommand, clonecommand;
	char sv[] = "-stick";
	char fv[] = "-float";
	char qv[] = "-noquit";

	if (opts->sticky)
	{
		SmPropValue stickprop_value;
		stickprop_value.value = sv;
		stickprop_value.length = 6;
		command[numvals++] = stickprop_value;
	}
	
	if (opts->ontop)
	{
		SmPropValue floatprop_value;
		floatprop_value.value = fv;
		floatprop_value.length = 6;
		command[numvals++] = floatprop_value;
	}

	if (opts->noquit)
	{
		SmPropValue noquitprop_value;
		noquitprop_value.value = qv;
		noquitprop_value.length = 7;
		command[numvals++] = noquitprop_value;
	}
	
	SmPropValue image_value;
	char* imagestr = new char[strlen(opts->image) + 3];
	imagestr[0] = '-'; imagestr[1] = 'F';
	strcpy(imagestr + 2, opts->image);
	image_value.value = imagestr;
	image_value.length = strlen(imagestr);
	command[numvals++] = image_value;
	
	SmPropValue smcid_value;
	std::string c_smcidarg("-smcid");
	c_smcidarg.append(opts->smcid);
	char* smcidarg = new char[c_smcidarg.length() + 1];
	strcpy(smcidarg, c_smcidarg.c_str());
	smcid_value.value = smcidarg;
	smcid_value.length = c_smcidarg.length();
	command[numvals++] = smcid_value;
	
	restartcommand.num_vals = numvals;
	clonecommand.num_vals = numvals - 1;
	restartcommand.vals = command;
	clonecommand.vals = command;
	
	restartcommand.name = SmRestartCommand;
	restartcommand.type = SmLISTofARRAY8;
	clonecommand.name = SmCloneCommand;
	clonecommand.type = SmLISTofARRAY8;
	
	SmProp* props[5];
	props[0] = &progname;
	props[1] = &uid;
	props[2] = &cwd;
	props[3] = &restartcommand;
	props[4] = &clonecommand;
	SmcSetProperties(conn, 5, props);
	
	// Delete any non-const things we had to explicitly allocate
	delete[] uidstr;
	delete[] cwdstr;
	delete[] smcidarg;
	delete[] imagestr;

	// Send SaveYourselfDone.
	SmcSaveYourselfDone(conn, True);
}

// Session management "Save complete" callback
void sm_save_complete(SmcConn conn, SmPointer data)
{
}

// Session management "Die" callback
void sm_die(SmcConn conn, SmPointer data)
{
	// TODO - Have GTK quit event handler disconnect from SM if in use
	SmcCloseConnection(conn, 0, NULL);
	gtk_main_quit();
}

// Pump ICE messages when data comes in
gboolean sm_pump_ice(GIOChannel* chan, GIOCondition cond, gpointer data)
{
	IceProcessMessages(static_cast<IceConn>(data), NULL, NULL);
	return true;
}

// Called whenever an ICE connection is opened or closed
void ice_connection_watch(IceConn conn, IcePointer data, Bool opening, IcePointer* wdata)
{
		if (opening)
		{
			// When we get a new ICE connection, install a IO channel which will pump
			// ICE messages when data is waiting
			int icefd = IceConnectionNumber(conn);
			GIOChannel* ioc = g_io_channel_unix_new(icefd);
			g_io_add_watch(ioc, G_IO_IN, sm_pump_ice, conn);
			*wdata = ioc;
		} else {
			// When an ICE connection closes, close the IO channel
			g_io_channel_unref(static_cast<GIOChannel*>(*wdata));
		}
}
#endif

// Entry point
int main (int argc, char* argv[])
{
	gtk_init(&argc, &argv);
	
	// Whether or not to set the window's keep-on-top hint
	bool ontop = false;

	// Whether or not the window's sticky hint should be set
	bool sticky = false;

	// Whether or not to fork into the background
	bool background = true;

#ifdef __USE_SM
	// Whether or not to use session management
	bool sm = true;

	// Old session client ID, if being restored from a saved session
	char* oldsmcid = NULL;

	// Set of callbacks
	smopts opts;
	SmcCallbacks smcallbacks;
	smcallbacks.save_yourself.callback = sm_save_yourself;
	smcallbacks.save_yourself.client_data = &opts;
	smcallbacks.die.callback = sm_die;
	smcallbacks.die.client_data = NULL;
	smcallbacks.save_complete.callback = sm_save_complete;
	smcallbacks.save_complete.client_data = NULL;
#endif

	// Mimic the image loading behaviour of xteddy, to an extent.
	{
		// Start from the name of the executable itself
		std::string image(argv[0]);
#ifdef __USE_SM
		char* smimage = argv[0];
#endif
		
		// Take just the last component of the path
		std::string::size_type s = image.find_last_of('/');
		if (s != std::string::npos)
			image = image.substr(s + 1);
		
		// Parse options
		// XXX This code is really quick and nasty
		for (int i = 1; i < argc; ++i)
		{
			// Allow image specification with -F<file>
			if (strncmp(argv[i], "-F", 2) == 0)
			{
				image = argv[i] + 2;
#ifdef __USE_SM
				smimage = argv[i] + 2;
#endif
			}
			// Allow disablement of "q" keybinding
			else if (strncmp(argv[i], "-noquit", 7) == 0)
				noquit = true;
			// Allow keep-on-top
			else if (strncmp(argv[i], "-float", 6) == 0)
				ontop = true;
			// Allow sticking to all desktops
			else if (strncmp(argv[i], "-stick", 6) == 0)
				sticky = true;
			// Allow disablement of backgrounding
			// Implies -nosm (see below)
			else if (strncmp(argv[i], "-nobg", 5) == 0)
				background = false;
#ifdef __USE_SM
			// Allow disablement of session management
			else if (strncmp(argv[i], "-nosm", 5) == 0)
				sm = false;
			// Read in old session client ID
			else if (strncmp(argv[i], "-smcid", 6) == 0)
				oldsmcid = argv[i] + 6;
#endif
			else if (strncmp(argv[i], "-h", 2) == 0 || strncmp(argv[i], "--help", 6) == 0)
			{
				std::cout << "Usage: cteddy [options]" << std::endl << std::endl;
				std::cout << "-F<image>" << std::endl;
				std::cout << "\tDisplay an image other than xteddy" << std::endl;
				std::cout << "-float" << std::endl;
				std::cout << "\tFloat above other windows" << std::endl;
				std::cout << "-stick" << std::endl;
				std::cout << "\tStick to all desktops" << std::endl;
				std::cout << "-noquit" << std::endl;
				std::cout << "\tDisable the 'q' quit keybinding" << std::endl;
				std::cout << "-nosm" << std::endl;
				std::cout << "\tDisable session management support" << std::endl;
				std::cout << "-nobg" << std::endl;
				std::cout << "\tDo not detach from terminal (implies -nosm)" << std::endl;
				std::cout << "--help, -h" << std::endl;
				std::cout << "\tOutput this message" << std::endl;
				std::cout << "--version, -v" << std::endl;
				std::cout << "\tOutput version number and build information" << std::endl;
				return 0;
			}
			else if (strncmp(argv[i], "-v", 2) == 0 || strncmp(argv[i], "--version", 9) == 0)
			{
				std::cout << PACKAGE_STRING << std::endl << std::endl;
				std::cout << "Build options: " << CONFIGURE_OPTS << std::endl;
				return 0;
			}
			else
				std::cerr << "Unrecognised option: " << argv[i] << std::endl;
		}

#ifdef __USE_SM
		// If we're being restarted by the session manager, don't bother
		// backgrounding, as we aren't attached to a terminal anyway
		if (sm && oldsmcid != NULL)
			background = false;
		
		// On the other hand, don't use session management if not forking
		// into the background, if being started directly by the user
		// rather than restarted as part of session.
		// XXX This is how -nobg imples -nosm.
		else if (!background && oldsmcid == NULL)
			sm = false;

		if (sm)
		{
			// Open & monitor a GIOChannel each time there is a new ICE connection
			IceAddConnectionWatch(ice_connection_watch, NULL);
			
			// Fill in SM opts so sm_save_yourself can set properties
			opts.sticky = sticky;
			opts.ontop = ontop;
			opts.noquit = noquit;
			opts.progname = argv[0];
			opts.image = smimage;
		
			// Try to connect to the session manager, displaying an error if we can't
			char smerr[512];
			memset(smerr, '\0', 512);
			if (SmcOpenConnection(NULL, NULL, SmProtoMajor, SmProtoMinor,
				SmcSaveYourselfProcMask | SmcDieProcMask | SmcSaveCompleteProcMask,
				&smcallbacks, oldsmcid, &(opts.smcid), 512, smerr) == NULL)
			{
				if (strlen(smerr) == 0)
					std::cerr << "Cannot connect to session manager; unknown error." << std::endl;
				else
					std::cerr << "Cannot connect to session manager: " << smerr << std::endl;

				// Continue anyway, just without SM (for convenience of anyone without a session manager)
				sm = false;
			}
		}

		// TODO - Use GTK dialogues to display errors, not stderr, as we may not be attached to a terminal
#endif
		
		// If the given path contains slashes, assume it is absolute or
		// relative to the current working directory and use it verbatim.
		// Otherwise, search for it.
		if (image.find_last_of('/') == std::string::npos)
		{
			// Search for the image
			bool found = false;
			std::string searchimage(PKGDATADIR "/");
			searchimage.append(image);
			found = image_exists(image, searchimage);
			// Try converting a leading x to a c and vice versa
			if (!found && image.at(0) == 'x')
			{
				std::string ximage(PKGDATADIR "/c");
				ximage.append(image.substr(1));
				found = image_exists(image, ximage);
			}
			if (!found && image.at(0) == 'c')
			{
				std::string ximage(PKGDATADIR "/x");
				ximage.append(image.substr(1));
				found = image_exists(image, ximage);
			}
			// Try prepending c or x
			if (!found)
			{
				std::string ximage(PKGDATADIR "/c");
				ximage.append(image);
				found = image_exists(image, ximage);
			}
			if (!found)
			{
				std::string ximage(PKGDATADIR "/x");
				ximage.append(image);
				found = image_exists(image, ximage);
			}
			
			if (!found)
			{
				std::cerr << "Cannot find image!" << std::endl;
				return 1;
			}
		}

		// Load the image from the supplied file path
		pixbuf = gdk_pixbuf_new_from_file(image.c_str(), &gerr);
		if (gerr)
		{
			std::cerr << "Cannot load image \"" << image << "\": " << gerr->message << std::endl;
			g_error_free(gerr);
			return 1;
		}
	}

	// Create the window
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	// Top-level windows don't normally respond to mouse button events directly.
	// We want this one to, though.
	gtk_widget_add_events(window, GDK_BUTTON_PRESS_MASK);
	
	// Set up event callbacks
	g_signal_connect(G_OBJECT(window), "expose-event", G_CALLBACK(handle_expose), NULL);
	g_signal_connect(G_OBJECT(window), "destroy", G_CALLBACK(gtk_main_quit), NULL);
	g_signal_connect(G_OBJECT(window), "button-press-event", G_CALLBACK(window_clicked), NULL);
	g_signal_connect(G_OBJECT(window), "screen-changed", G_CALLBACK(handle_screen), NULL);
	g_signal_connect(G_OBJECT(window), "key-press-event", G_CALLBACK(handle_key_press), NULL);
	
	// Grab pixmap and alpha-thresholded bitmap from original pixmap
	GdkPixmap* pixmap;
	gdk_pixbuf_render_pixmap_and_mask(pixbuf, &pixmap, &bitmap, 128);
	
	// Set window size to image size
	gdk_drawable_get_size(pixmap, &width, &height);
	gtk_widget_set_size_request(window, width, height);
	
	// If we have an alpha channel on the image, set the window's input shape,
	// clearing it completely first
	if (bitmap)
	{
		gtk_widget_input_shape_combine_mask(window, NULL, 0, 0);
		gtk_widget_input_shape_combine_mask(window, bitmap, 0, 0);
	}
	
	// Deref the pixmap, but keep the bitmap around for now
	// May be useful later for setting window's shape mask if we cannot get
	// a true RGBA visual (i.e. compositing manager not running)
	g_object_unref(G_OBJECT(pixmap));

	// Set up various other properties we're interested in
	gtk_window_set_title(GTK_WINDOW(window), "cteddy");
	gtk_window_set_resizable(GTK_WINDOW(window), false);
	gtk_window_set_decorated(GTK_WINDOW(window), false);
	gtk_widget_set_app_paintable(window, true);
	gtk_window_set_icon(GTK_WINDOW(window), pixbuf);
	
	// Trigger initial attempt to switch to an RGBA colourmap
	handle_screen(window, NULL, NULL);

	// Have to do this before we can use window->window as a GdkWindow*
	gtk_widget_realize(window);

#ifdef __USE_SM
	// Set the window's SM client ID
	if (sm)
		gdk_set_sm_client_id(opts.smcid);
#endif

	{
		// Load in the heart-shaped cursor image and use it for our window's cursor
		GdkPixbuf* heart = 	gdk_pixbuf_new_from_file(PKGDATADIR "/heart.png", &gerr);
		if (gerr)
		{
			std::cerr << "Cannot load image: " << gerr->message << std::endl;
			g_error_free(gerr);
			return 1;
		}
		GdkCursor* cursor = gdk_cursor_new_from_pixbuf(gdk_display_get_default(),
			heart, 12, 12);
		gdk_window_set_cursor(window->window, cursor);
	}

	// Clear the window's default background
	gdk_window_set_back_pixmap(window->window, NULL, false);
	
	// Honour float & sticky options
	if (ontop)
		gtk_window_set_keep_above(GTK_WINDOW(window), true);
	if (sticky)
		gtk_window_stick(GTK_WINDOW(window));
	
	gtk_widget_show_all(window);

	// Fork into background if desired
	if (background)
	{
		pid_t p = fork();
		if (p < 0)
		{
			std::cerr << "Could not fork: " << strerror(errno) << std::endl;
			return 1;
		}
		else if (p == 0)
		{
			// Macro for performing a particular system call,
			// trying again if it returns EINTR, displaying an error otherwise
			#define __IGNORE_EINTR(fun, msg) \
				while(fun) \
				{ \
					if (errno == EINTR) \
						continue; \
					std::cerr << msg << strerror(errno) << std::endl; \
					return 1; \
				}

			// Close stdin
			__IGNORE_EINTR(close(0) != 0, "Could not close stdin: ");
			// Redirect stdout & stderr to /dev/null
			int nullfd;
			__IGNORE_EINTR((nullfd = open("/dev/null", O_WRONLY)) < 0, "Cannot open /dev/null: ");
			__IGNORE_EINTR(dup2(nullfd, 1) < 0, "Cannot redirect stdout to /dev/null: ");
			__IGNORE_EINTR(dup2(nullfd, 2) < 0, "Cannot redirect stderr to /dev/null: ");
			// Create new process session
			if (setsid() < 0)
			{
				std::cerr << "Cannot create new session: " << strerror(errno) << std::endl;
				return 1;
			}
		}
		else
			return 0;
	}

	gtk_main();
	
	return 0;
}
